package backend

import (
	"cron_admin/app/http/controllers"
	"cron_admin/app/http/entities"
	"cron_admin/app/http/entities/backend"
	"cron_admin/app/models/cronreportchannelmodel"
	"cron_admin/app/services"
	"github.com/ahmetb/go-linq/v3"
	"github.com/gin-gonic/gin"
)

func ReportChannelCreate(c *gin.Context) {
	req, _ := controllers.GetRequest(c).(*backend.ReportChannelCreateRequest)
	reportChannel := req.Request2DB()
	err := services.ReportChannelCreate(&reportChannel)
	controllers.HandRes(c, req, err)

}

func ReportChannelList(c *gin.Context) {
	req, _ := controllers.GetRequest(c).(*backend.ReportChannelListRequest)
	param, err := req.Request2DB()
	if err != nil {
		controllers.HandRes(c, nil, err)
		return
	}

	data, total, err := services.ReportChannelList(param)
	if err != nil {
		controllers.HandRes(c, nil, err)
		return
	}
	list := make([]backend.ReportChannelListResponse, 0, len(data))
	linq.From(data).SelectT(func(in cronreportchannelmodel.CronReportChannel) backend.ReportChannelListResponse {
		var out backend.ReportChannelListResponse
		out.FromDb(in)
		return out
	}).ToSlice(&list)

	controllers.HandRes(c, entities.PageRsp{
		Total: total,
		Data:  list,
	}, nil)
}

func ReportChannelUpdate(c *gin.Context) {
	req, _ := controllers.GetRequest(c).(*backend.ReportChannelUpdateRequest)
	reportChannel := req.Request2DB()
	total, err := services.ReportChannelUpdate(&reportChannel)
	controllers.HandRes(c, total, err)
}

func ReportChannelDelete(c *gin.Context) {
	req, _ := controllers.GetRequest(c).(*entities.IdRequest)
	total, err := services.ReportChannelDelete(*req)
	controllers.HandRes(c, total, err)
}
